%Euler Forward code
dx=0.01;J=1/dx+1;b=1;
dt=0.501*dx^2/b;nt=0.5/dt;mu=b*dt/dx^2;
u=ones(J,1);%initial condition
%time loop
for it=1:nt
    %first interior nodes
    for j=2:J-1
        unext(j)=u(j)+mu*(u(j-1)-2*u(j)+u(j+1));
    end
    %B.C.
    unext(1)=0;unext(J)=0;
    %update for next step
    u=unext;
    x=0:dx:1;
plot(x,u)
ylim([0 1])
pause(0.001)
end
% x=0:dx:1;
% plot(x,u)
