function x=thomas(a,b,c,r)
n=length(b);
% LU decomposition step
f(1)=b(1);
g(1)=c(1)/f(1);
for j=2:n
    e(j)=a(j);
    f(j)=b(j)-e(j)*g(j-1);
    g(j)=c(j)/f(j);
end
% forward solve [L]y=r
y(1)=r(1)/f(1);
for j=2:n
    y(j)=(r(j)-e(j)*y(j-1))/f(j);
end
% backward solve [U]x=y
x(n)=y(n);
for j=n-1:-1:1
    x(j)=y(j)-g(j)*x(j+1);
end